<template>
  <div :class="className" :style="{height:height,width:width}" />
</template>

<script>
import echarts from 'echarts';
// require('echarts/theme/roma');
require('../../../theme/RitxChart');
import { debounce } from '@/utils';

export default {
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    width: {
      type: String,
      default: '100%'
    },
    height: {
      type: String,
      default: '300px'
    }
  },
  data() {
    return {
      chart: null
    };
  },
  mounted() {
    this.initChart();
    this.__resizeHandler = debounce(() => {
      if (this.chart) {
        this.chart.resize();
      }
    }, 100);
    window.addEventListener('resize', this.__resizeHandler);
  },
  beforeDestroy() {
    if (!this.chart) {
      return;
    }
    window.removeEventListener('resize', this.__resizeHandler);
    this.chart.dispose();
    this.chart = null;
  },
  methods: {
    initChart() {
      this.chart = echarts.init(this.$el, 'ritx');
      // const data = echarts.getOption().series[0].data;
      this.chart.setOption({
        tooltip: {
          trigger: 'item',
          formatter: '{a} <br/>{b} : {c} ({d}%)'
        },
        legend: {
          left: '10',
          top: '10',
          data: [{ value: 600, name: 'Male' }, { value: 400, name: 'Female' }],
          orient: 'vertical',
          formatter: name => {
            /* const totalValue = data.reduce((acc, item) => {
              acc += item.value;
              return acc;
            }, 0);
            let targetValue;
            data.forEach(item => {
              if (item.name === name) {
                targetValue = item.value;
              }
            });
            const p = ((targetValue / totalValue) * 100).toFixed(2); */
            return name + ' ' + '%';
          }
        },
        calculable: true,

        /* visualMap: {
          rigth: 10,
          top: 10,
          formatter: function(value, value2) {
            // let fux '<h1 style=’color:red;’> hello user </h1>';
            // const message = '<h1>A test string</h1>';
            const btn = document.createElement('BUTTON'); // Create a <button> element
            btn.innerHTML = 'CLICK ME'; // Insert text

            return `${value} to ${value2}`;
          },
          pieces: [
            {
              gt: 0,
              lte: 50
            },
            {
              gt: 50,
              lte: 100
            }
          ],
          outOfRange: {
            color: '#999'
          }
        }, */
        series: [
          {
            name: 'Gender Petani',
            type: 'pie',
            avoidLabelOverlap: true,
            radius: [50, 100],
            data: [{ value: 600, name: 'Male' }, { value: 400, name: 'Female' }],
            animationEasing: 'cubicInOut',
            animationDuration: 2600,
            label: {
              normal: {
                formatter: [
                  '{title|{b}}{abg|}',
                  '  {weatherHead|Female}{valueHead|Male}',
                  '{hr|}',
                  '  {Sunny|}{value|202}{rate|55.3%}',
                  '  {Cloudy|}{value|142}{rate|38.9%}',
                  '  {Showers|}{value|21}{rate|5.8%}'
                ].join('\n'),
                backgroundColor: '#eee',
                borderColor: '#777',
                borderWidth: 1,
                borderRadius: 4,
                rich: {
                  title: {
                    color: '#eee',
                    align: 'center'
                  },
                  abg: {
                    backgroundColor: '#333',
                    width: '100%',
                    align: 'right',
                    height: 25,
                    borderRadius: [4, 4, 0, 0]
                  },
                  Sunny: {
                    height: 30,
                    align: 'left'
                  },
                  Cloudy: {
                    height: 30,
                    align: 'left'
                  },
                  Showers: {
                    height: 30,
                    align: 'left'
                  },
                  weatherHead: {
                    color: '#333',
                    height: 24,
                    align: 'left'
                  },
                  hr: {
                    borderColor: '#777',
                    width: '100%',
                    borderWidth: 0.5,
                    height: 0
                  },
                  value: {
                    width: 20,
                    padding: [0, 20, 0, 30],
                    align: 'left'
                  },
                  valueHead: {
                    color: '#333',
                    width: 20,
                    padding: [0, 20, 0, 30],
                    align: 'center'
                  },
                  rate: {
                    width: 40,
                    align: 'right',
                    padding: [0, 10, 0, 0]
                  },
                  rateHead: {
                    color: '#333',
                    width: 40,
                    align: 'center',
                    padding: [0, 10, 0, 0]
                  }
                }
              }
            }
          }
        ]
      });
    }
  }
};
</script>
